diff --git a/drivers/firmware/Kconfig b/drivers/firmware/Kconfig
index fbd785dd0513..41de77d2720e 100644
--- a/drivers/firmware/Kconfig
+++ b/drivers/firmware/Kconfig
@@ -305,5 +305,6 @@ source "drivers/firmware/psci/Kconfig"
 source "drivers/firmware/smccc/Kconfig"
 source "drivers/firmware/tegra/Kconfig"
 source "drivers/firmware/xilinx/Kconfig"
+source "drivers/firmware/intel/Kconfig"
 
 endmenu
diff --git a/drivers/firmware/Makefile b/drivers/firmware/Makefile
index 99510be9f5ed..00f295ab9860 100644
--- a/drivers/firmware/Makefile
+++ b/drivers/firmware/Makefile
@@ -33,3 +33,4 @@ obj-y				+= psci/
 obj-y				+= smccc/
 obj-y				+= tegra/
 obj-y				+= xilinx/
+obj-y				+= intel/
diff --git a/drivers/firmware/intel/Kconfig b/drivers/firmware/intel/Kconfig
new file mode 100644
index 000000000000..b2b7a4e5410b
--- /dev/null
+++ b/drivers/firmware/intel/Kconfig
@@ -0,0 +1,14 @@
+# SPDX-License-Identifier: GPL-2.0-only
+menu "Intel Firmware Drivers"
+
+config KEEMBAY_FIRMWARE
+	bool "Enable Keem Bay firmware interface support"
+	depends on HAVE_ARM_SMCCC
+	default n
+	help
+	  Firmware interface driver is used by device drivers
+	  to communicate with the arm-trusted-firmware
+	  for platform management services.
+	  If in doubt, say "N".
+
+endmenu
diff --git a/drivers/firmware/intel/Makefile b/drivers/firmware/intel/Makefile
new file mode 100644
index 000000000000..e6d2e1ea69a7
--- /dev/null
+++ b/drivers/firmware/intel/Makefile
@@ -0,0 +1,4 @@
+# SPDX-License-Identifier: GPL-2.0
+# Makefile for Intel firmwares
+
+obj-$(CONFIG_KEEMBAY_FIRMWARE) = keembay_smc.o
diff --git a/drivers/firmware/intel/keembay_smc.c b/drivers/firmware/intel/keembay_smc.c
new file mode 100644
index 000000000000..24013cd1f5da
--- /dev/null
+++ b/drivers/firmware/intel/keembay_smc.c
@@ -0,0 +1,119 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ *  Copyright (C) 2020-2021, Intel Corporation
+ */
+
+#include <linux/arm-smccc.h>
+#include <linux/init.h>
+#include <linux/module.h>
+#include <linux/of_platform.h>
+
+#include <linux/firmware/intel/keembay_smc.h>
+
+static noinline int do_fw_call_fail(u64 arg0, u64 arg1)
+{
+	return -ENODEV;
+}
+
+/**
+ * Simple wrapper functions to be able to use a function pointer
+ * Invoke do_fw_call_smc or others in future, depending on the configuration
+ */
+static int (*do_fw_call)(u64, u64) = do_fw_call_fail;
+
+/**
+ * do_fw_call_smc() - Call system-level platform management layer (SMC)
+ * @arg0:		Argument 0 to SMC call
+ * @arg1:		Argument 1 to SMC call
+ *
+ * Invoke platform management function via SMC call.
+ *
+ * Return: Returns status, either success or error
+ */
+static noinline int do_fw_call_smc(u64 arg0, u64 arg1)
+{
+	struct arm_smccc_res res;
+
+	arm_smccc_smc(arg0, arg1, 0, 0, 0, 0, 0, 0, &res);
+
+	return res.a0;
+}
+
+/**
+ * keembay_sd_voltage_selection() - Set the IO Pad voltage
+ * @volt: voltage selection either 1.8V or 3.3V
+ *
+ * This function is used to set the IO Line Voltage
+ *
+ * Return: 0 for success, Invalid for failure
+ */
+int keembay_sd_voltage_selection(int volt)
+{
+	return do_fw_call(KEEMBAY_SIP_FUNC_ID, volt);
+}
+EXPORT_SYMBOL_GPL(keembay_sd_voltage_selection);
+
+/**
+ * keembay_get_invoke_func() - method of call
+ * @np:	Pointer to the device_node structure
+ *
+ * Return: Returns 0 on success or error code
+ */
+static int keembay_get_invoke_func(struct device_node *np)
+{
+	const char *method;
+
+	if (of_property_read_string(np, "method", &method)) {
+		pr_warn("%s missing \"method\" property\n", __func__);
+		return -ENXIO;
+	}
+
+	if (!strcmp("smc", method)) {
+		do_fw_call = do_fw_call_smc;
+	} else {
+		pr_warn("%s Invalid \"method\" property: %s\n",
+			__func__, method);
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+static int keembay_firmware_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	int ret;
+
+	ret = keembay_get_invoke_func(dev->of_node);
+	if (ret) {
+		dev_err(&pdev->dev, "Failed to get method of call\n");
+		return ret;
+	}
+
+	return 0;
+}
+
+static int keembay_firmware_remove(struct platform_device *pdev)
+{
+	return 0;
+}
+
+static const struct of_device_id keembay_firmware_of_match[] = {
+	{.compatible = "keembay,firmware"},
+	{},
+};
+MODULE_DEVICE_TABLE(of, keembay_firmware_of_match);
+
+static struct platform_driver keembay_firmware_driver = {
+	.driver = {
+		.name = "keembay_firmware",
+		.of_match_table = keembay_firmware_of_match,
+	},
+	.probe = keembay_firmware_probe,
+	.remove = keembay_firmware_remove,
+};
+module_platform_driver(keembay_firmware_driver);
+
+MODULE_LICENSE("GPL v2");
+MODULE_DESCRIPTION("Intel Keembay SOC Firmware Layer");
+MODULE_AUTHOR("Muhammad Husaini Zulkifli <Muhammad.Husaini.Zulkifli@intel.com>");
diff --git a/include/linux/firmware/intel/keembay_smc.h b/include/linux/firmware/intel/keembay_smc.h
new file mode 100644
index 000000000000..87b1417f7e4e
--- /dev/null
+++ b/include/linux/firmware/intel/keembay_smc.h
@@ -0,0 +1,27 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ *  Intel Keembay SOC Firmware Layer
+ *
+ *  Copyright (C) 2020-2021, Intel Corporation
+ *
+ *  Muhammad Husaini Zulkifli <Muhammad.Husaini.Zulkifli@intel.com>
+ */
+
+#ifndef __FIRMWARE_KEEMBAY_SMC_H__
+#define __FIRMWARE_KEEMBAY_SMC_H__
+
+/* Setting for Keem Bay IO Pad Line Voltage Selection */
+#define KEEMBAY_SIP_FUNC_ID	0x8200ff26
+#define KEEMBAY_SET_1V8_VOLT	0x01
+#define KEEMBAY_SET_3V3_VOLT	0x00
+
+#if IS_ENABLED(CONFIG_KEEMBAY_FIRMWARE)
+int keembay_sd_voltage_selection(int volt);
+#else
+static inline int keembay_sd_voltage_selection(int volt)
+{
+	return -ENODEV;
+}
+#endif
+
+#endif /* __FIRMWARE_KEEMBAY_SMC_H__ */